/**************************************************************************
*   Amarok 2 Good Night                                                   *
*                                                                         *
*   Copyright                                                             *
*   (C) 2010 Rico Zienke <zonken@web.de>                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
**************************************************************************/  

// check at first version and leave for amarok version < 2.2
Amarok.debug(Amarok.Info.version());
if (Amarok.Info.version() == "2.0.0"
||  Amarok.Info.version() == "2.0.1"  
||  Amarok.Info.version() == "2.0.2" 
||  Amarok.Info.version() == "2.1.0"){
Amarok.alert( "This script requieres at least Amarok 2.2.0. Script stopped!",  "error" );
}else
{ 
/********************************* Import QT ******************************/  
Importer.loadQtBinding("qt.core");
Importer.loadQtBinding("qt.gui");
Importer.loadQtBinding("qt.uitools");

/***************************** Init Global Data ***************************/ 
var gv_pbOnOff        = false;
var gv_cbLogOutDialog = true;
var gv_rbAfterHour    = false;
var gv_rbPlayList     = true;
var gv_ddCurrentIndex = 0;
var gv_cancelTimer    = new QObject(); 
var gv_hoursTimer     = new QObject();
var gv_statusTimer    = new QObject();
var gv_teHours        = new QTime(0,1);
var gv_teTimeLeft     = new QTime();
var gv_milsec;
var gv_sbCancelWait   = 10;
var gv_toolsDialog;
var gv_gbOption;
var gv_cancelDialog;
var gv_uiLoader       = new QUiLoader(this);
var gv_uiFile         = new QFile (Amarok.Info.scriptPath() + "/gn_gui.ui");
var gv_init           = true;


function GNShutDownPopUpTimer(interval) {
/**************************************************************************/ 
// set each second ++ to progress bar for cancel pop up of shutdown
/**************************************************************************/ 
   debug("GNShutDownPopUpTimer");

   Amarok.debug("start gv_cancelDialog.pbTime.maximum = " + gv_cancelDialog.pbTime.maximum + "gv_cancelDialog.pbTime.value :" + gv_cancelDialog.pbTime.value);
     gv_cancelTimer.event = function(qevent) {
      if (gv_cancelDialog.pbTime.value == gv_cancelDialog.pbTime.maximum){
//     time is over kill timer and leave
       this.killTimer(gv_cancelTimer.timerID);
       Amarok.debug("end gv_cancelDialog.pbTime.maximum = " + gv_cancelDialog.pbTime.maximum + "gv_cancelDialog.pbTime.value :" + gv_cancelDialog.pbTime.value); 
       try{gv_cancelDialog.pbTime.buttonBox.enabled = false;}catch(e){Amarok.debug(e);}
       try{gv_cancelDialog.pbTime.format = qsTranslate("GoodNightGUI","Good Night!");}catch(e){Amarok.debug(e);}
       GNShutDown(true);
       return true;
     } else {
       Amarok.debug("count gv_cancelDialog.pbTime.maximum = " + gv_cancelDialog.pbTime.maximum + "gv_cancelDialog.pbTime.value :" + gv_cancelDialog.pbTime.value);
       gv_cancelDialog.pbTime.value++;
       seconds = gv_cancelDialog.pbTime.maximum - gv_cancelDialog.pbTime.value;
       gv_cancelDialog.pbTime.format = seconds + qsTranslate("GoodNightGUI"," seconds to left");
      }
   }
   Amarok.debug(gv_cancelTimer.timerID + " + " + interval);
   gv_cancelTimer.timerID = gv_cancelTimer.startTimer(interval);
}

function GNShutDownPopUp(){
/**************************************************************************/ 
// shut down popup
/**************************************************************************/ 
 debug("GNShutDownPopUp");

 var uiLoader       = new QUiLoader(this);
 var uiFile         = new QFile (Amarok.Info.scriptPath() + "/gn_cancel.ui");
 
// load file
 uiFile.open(QIODevice.ReadOnly);
 gv_cancelDialog = uiLoader.load(uiFile,this);
 uiFile.close();

// init prgress bar
 gv_cancelDialog.buttonBox.button(QDialogButtonBox.Abort).clicked.connect(null, GNShutDownCancel);
 gv_cancelDialog.pbTime.minimum = 0;
 gv_cancelDialog.pbTime.maximum =  gv_sbCancelWait;
 gv_cancelDialog.pbTime.value =  0;

// init timer
 GNShutDownPopUpTimer(1000);
 gv_cancelDialog.show();
}

function GNShutDownCancel(){
/**************************************************************************/ 
// shut down logic
/**************************************************************************/ 
  debug("GNShutDownCancel");

  gv_pbOnOff = false;
  gv_toolsDialog.pbOnOff.checked = gv_pbOnOff;
  try{gv_cancelTimer.killTimer(gv_cancelTimer.timerID);}catch(e){Amarok.debug(e);}
  gv_cancelTimer    = new QObject(); 
  GNProcessAfterAction();
  GNProcessBeforeOutput();
}

function GNShutDown(supressPopUp){
/**************************************************************************/ 
// shut down logic
/**************************************************************************/ 
  var image = new QImage(Amarok.Info.scriptPath() + "/icons/weather-clear-night.png");
  debug("GNShutDown");

  //switch off GN first
  gv_pbOnOff = false;
  gv_toolsDialog.pbOnOff.checked = gv_pbOnOff;
  
  //call pop up first
  if (gv_cbLogOutDialog == true
  &&  supressPopUp == false){
    GNShutDownPopUp();
    return;
  }
   try{gv_cancelTimer.killTimer(gv_cancelTimer.timerID);}catch(e){Amarok.debug(e);}
   gv_cancelTimer    = new QObject(); 

  //long message to inform user that amarok will shutdown now
  Amarok.Window.OSD.setDuration(3000);
  Amarok.Window.OSD.setImage(image);
  Amarok.Window.OSD.setText(qsTranslate("GoodNightGUI", "Good Night was executed!"));
  Amarok.Window.OSD.show();


  Amarok.Window.Statusbar.shortMessage(qsTranslate("GoodNightGUI","Good Night!"));
  Amarok.Engine.Stop(true);

  //timer so that infos can be read before shut down process starts
  var timer = new QObject();
  timer.count = 0;
  timer.event = function(qevent) {
    this.killTimer(timer.timerID);
    switch (gv_toolsDialog.ddKindShutdown.currentText){
    case qsTranslate("GoodNightGUI","Shutdown PC"): 
      process = new QProcess();  
      process.start("/usr/bin/qdbus org.kde.ksmserver /KSMServer logout 0 2 2");
    break;
    case qsTranslate("GoodNightGUI","Hibernate"):
      process = new QProcess();
      process.start("/usr/bin/qdbus org.freedesktop.PowerManagement /org/freedesktop/PowerManagement org.freedesktop.PowerManagement.Hibernate");
    break;
    case qsTranslate("GoodNightGUI","Sleep"):
      process = new QProcess();
      process.start("/usr/bin/qdbus org.freedesktop.PowerManagement /org/freedesktop/PowerManagement org.freedesktop.PowerManagement.Suspend"); 
    break; 
    case qsTranslate("GoodNightGUI","Quit Amarok"):
      Amarok.quitAmarok();
    break;
    case qsTranslate("GoodNightGUI","Stop Amarok"):
      Amarok.Engine.Stop();
    break;
    }
  }
  timer.timerID = timer.startTimer(3000);
}

function GNOnTrackChanged( ){
/**************************************************************************/ 
// update progress bar
/**************************************************************************/ 
  debug("GNOnTrackChanged");
  if (gv_pbOnOff){
    GNProcessBeforeOutput();
  }
}

function GNOnTrackFinished(){
/**************************************************************************/ 
// this functions reacts on end of track,
// checks: function is enabled; last song in list
// turn off PC 
/**************************************************************************/ 
debug("GNOnTrackFinished");
Amarok.debug("active Index: "+Amarok.Playlist.activeIndex());
Amarok.debug("total track count:"+Amarok.Playlist.totalTrackCount());
  if  (Amarok.Playlist.totalTrackCount() > 0  // play list has at least an entry
  &&  gv_pbOnOff == true //script was switched on
  &&  gv_toolsDialog.rbPlayList.checked){ // we are running in play list mode
    // different amarok verion behaviour
    if (Amarok.Playlist.activeIndex() == -1
    || (Amarok.Playlist.activeIndex()+1 == Amarok.Playlist.totalTrackCount())){
      // last track is over
      //first diconnect, Amarok raises event more then one time (double popups) :-/
      try{Amarok.Engine.trackFinished.disconnect( GNOnTrackFinished );
      }catch(e){Amarok.debug(e);}
      try{Amarok.Engine.trackChanged.disconnect( GNOnTrackChanged );
      }catch(e){Amarok.debug(e);}
      GNCancelTimer();//init progress bar
      GNShutDown(false);
     }
  }
  GNSetProgressBar();
}

function GNCancelTimer(){
/**************************************************************************/ 
// kill timer and set back instance
/**************************************************************************/ 
  debug("GNCancelTimer");

// set back timer for shut down  
  gv_hoursTimer.killTimer(gv_hoursTimer.timerID);
  gv_hoursTimer     = new QObject();
  Amarok.debug("shutdown timer killed");

//init timer of progress bar  
  gv_statusTimer.killTimer(gv_statusTimer.timerID);
  gv_statusTimer = new QObject();
  gv_toolsDialog.pbCurrentStatus.minimum = 0;
  gv_toolsDialog.pbCurrentStatus.value = 0;
  gv_toolsDialog.pbCurrentStatus.maximum = 1;
  Amarok.debug("progressbar timer killed");
}

function GNActionClose(){
/**************************************************************************/ 
// after close  button was called
/**************************************************************************/
  debug("GNActionClose");
  if (!gv_init){
  //GNSetGN();
  GNProcessAfterAction();
  // save config
  GNWriteConfig();
  }
}

function GNActionLogOutDialog(){
/**************************************************************************/ 
// react on checkbox whether log out screen shall be skipped
/**************************************************************************/ 
  debug("GNActionLogOutDialog");
  if (!gv_init){
  GNProcessAfterAction();
  GNProcessBeforeOutput();
  }
}

function GNActionToggle(){
/**************************************************************************/ 
// after radiobutton, on off 
/**************************************************************************/
  debug("GNActionToggle");
  if (!gv_init){
  GNSetGN();
  GNProcessAfterAction();
  GNProcessBeforeOutput();
  }
}

function GNSetGN(){
/**************************************************************************/ 
// call action 
/**************************************************************************/ 
debug("GNSetGN");

// message needed?
  if (gv_pbOnOff     != gv_toolsDialog.pbOnOff.checked
  ||  gv_rbAfterHour != gv_toolsDialog.rbAfterHour.checked
  ||  gv_rbPlayList  != gv_toolsDialog.rbPlayList.checked){
    if (gv_pbOnOff != gv_toolsDialog.pbOnOff.checked){
       if (gv_toolsDialog.pbOnOff.checked){
      Amarok.Window.Statusbar.shortMessage(qsTranslate("GoodNightGUI","Good Night started"));
      } else
      Amarok.Window.Statusbar.shortMessage(qsTranslate("GoodNightGUI","Good Night stopped"));
    }
  }
// do action now
  if (gv_toolsDialog.pbOnOff.checked){
    if (gv_toolsDialog.rbAfterHour.checked){
      // 0 makes no sence
      if (gv_toolsDialog.teHours.time == "00:00:00"){
	gv_teHours = new QTime(0,1);
	gv_toolsDialog.teHours.time = gv_teHours;
      } else {  
	gv_teHours = gv_toolsDialog.teHours.time;
      }
      GNCancelTimer();
      //disconnect to amarok track finsihed event if connection exists
      try{Amarok.Engine.trackFinished.disconnect( GNOnTrackFinished );
	}catch(e){Amarok.debug(e);}
      try{Amarok.Engine.trackChanged.disconnect( GNOnTrackChanged );
	}catch(e){Amarok.debug(e);}
      //set timer again
      gv_hoursTimer.count = 0;
      gv_hoursTimer.event = function(qevent) {
        Amarok.debug("Timer event raised!");
	GNCancelTimer();
	if (gv_pbOnOff) {
	  GNShutDown(false);
	}
        return true;      
      }
      gv_milsec = (gv_teHours.hour()*60 + gv_teHours.minute())*60*1000;
      Amarok.debug("gv_milsec :" +  gv_milsec);
      gv_hoursTimer.timerID = gv_hoursTimer.startTimer(gv_milsec);  
//    start timer to update progressbar each X/100 based on time shut down
      gv_toolsDialog.pbCurrentStatus.minimum = 0;
      gv_toolsDialog.pbCurrentStatus.value = 0;
      gv_toolsDialog.pbCurrentStatus.maximum = gv_milsec;
      gv_statusTimer = new QObject();
      gv_statusTimer.count = 0;
      gv_statusTimer.event = function(qevent) {
	Amarok.debug("current time/max : " +  gv_toolsDialog.pbCurrentStatus.value +  "/" + gv_toolsDialog.pbCurrentStatus.maximum + "/" + gv_milsec);
        if (gv_toolsDialog.pbCurrentStatus.value < gv_milsec
        &&  gv_pbOnOff){
           gv_toolsDialog.pbCurrentStatus.value = gv_toolsDialog.pbCurrentStatus.value + (gv_milsec / 100) ;
           mseconds = gv_toolsDialog.pbCurrentStatus.maximum - gv_toolsDialog.pbCurrentStatus.value + (60*1000);
           gv_teTimeLeft = new QTime();
           gv_teTimeLeft = gv_teTimeLeft.addMSecs(mseconds);
           gv_toolsDialog.pbCurrentStatus.format = qsTranslate("GoodNightGUI","Good Night is active, time remaining: ") + gv_teTimeLeft.toString("hh:mm"); 
        }else{
           gv_statusTimer.killTimer(gv_statusTimer.timerID);
        }
	return true;      
      }
      gv_statusTimer.timerID = gv_statusTimer.startTimer(gv_milsec / 100 );
      gv_toolsDialog.pbCurrentStatus.value = gv_toolsDialog.pbCurrentStatus.value + (gv_milsec / 100) ;
      mseconds = gv_toolsDialog.pbCurrentStatus.maximum - gv_toolsDialog.pbCurrentStatus.value + (60*1000);
      gv_teTimeLeft = new QTime();
      gv_teTimeLeft = gv_teTimeLeft.addMSecs(mseconds);
      gv_toolsDialog.pbCurrentStatus.format = qsTranslate("GoodNightGUI","Good Night is active, time remaining: ") + gv_teTimeLeft.toString("hh:mm");       
    } else if (gv_rbPlayList){
      //end of play list is active: kill timer first
      GNCancelTimer();
      //register on corresponding amarok signal    
      Amarok.Engine.trackFinished.connect( GNOnTrackFinished );
      Amarok.Engine.trackChanged.connect( GNOnTrackChanged );
    } 

  }else {
//  script is off
    GNCancelTimer();
    try{Amarok.Engine.trackFinished.disconnect( GNOnTrackFinished );
	}catch(e){Amarok.debug(e);}
    try{Amarok.Engine.trackChanged.disconnect( GNOnTrackChanged );
	}catch(e){Amarok.debug(e);}

  } 
 
//prepare screen elments
  GNProcessBeforeOutput();
}

function GNProcessAfterAction(){
/**************************************************************************/ 
// set global variables after action was called
/**************************************************************************/ 
  debug("GNProcessAfterAction");

  if (gv_toolsDialog.cbLogOutDialog.checked != gv_cbLogOutDialog){
    gv_cbLogOutDialog = gv_toolsDialog.cbLogOutDialog.checked;
  }
  if (gv_toolsDialog.ddKindShutdown.currentIndex != gv_ddCurrentIndex){
    gv_ddCurrentIndex = gv_toolsDialog.ddKindShutdown.currentIndex;
  }
  if (gv_toolsDialog.sbCancelWait.value != gv_sbCancelWait){
    gv_sbCancelWait = gv_toolsDialog.sbCancelWait.value;
  }
  if (gv_pbOnOff != gv_toolsDialog.pbOnOff.checked){
    gv_pbOnOff = gv_toolsDialog.pbOnOff.checked;
  }
  if (gv_toolsDialog.rbAfterHour.checked != gv_rbAfterHour){
    gv_rbAfterHour = gv_toolsDialog.rbAfterHour.checked;
  }
  if (gv_toolsDialog.rbPlayList.checked != gv_rbPlayList){
    gv_rbPlayList  = gv_toolsDialog.rbPlayList.checked;
  }
  if (gv_toolsDialog.teHours.time != gv_teHours){
    gv_teHours = gv_toolsDialog.teHours.time;
  }
}
function GNSetProgressBar(){
/**************************************************************************/ 
// update statusbar 
/**************************************************************************/ 
  debug("GNSetProgressBar");
  if (gv_toolsDialog.pbOnOff.checked){
    if (gv_toolsDialog.rbPlayList.checked){
    // get the current and max entries from list an set values
      gv_toolsDialog.pbCurrentStatus.minimum = 0;
      gv_toolsDialog.pbCurrentStatus.maximum = Amarok.Playlist.totalTrackCount();
      gv_toolsDialog.pbCurrentStatus.value   = Amarok.Playlist.activeIndex();
      tracks = gv_toolsDialog.pbCurrentStatus.maximum - gv_toolsDialog.pbCurrentStatus.value;
      if (gv_toolsDialog.pbCurrentStatus.maximum == 0){
       gv_toolsDialog.pbCurrentStatus.maximum = 1;
       gv_toolsDialog.pbCurrentStatus.value = 0;
       gv_toolsDialog.pbCurrentStatus.format = qsTranslate("GoodNightGUI","Good Night is active, playlist is empty");
      } else{
        if (Amarok.Engine.engineState() == 2){
          gv_toolsDialog.pbCurrentStatus.format = qsTranslate("GoodNightGUI","Good Night is active, play stopped");
        }else if (Amarok.Engine.engineState() == 1){
         gv_toolsDialog.pbCurrentStatus.format = qsTranslate("GoodNightGUI","Good Night is active, play paused");   
        }else{
          gv_toolsDialog.pbCurrentStatus.format = qsTranslate("GoodNightGUI","Good Night is active, tracks remaining: ") + tracks; 
        }      
      }
    }else{
//  timer is active get time until end
      gv_toolsDialog.pbCurrentStatus.minimum = 0;
      gv_toolsDialog.pbCurrentStatus.maximum = gv_milsec;   

    }    
 }else{
   gv_toolsDialog.pbCurrentStatus.format = qsTranslate("GoodNightGUI","Good Night is inactive");
 }
  Amarok.debug("minimum: " + gv_toolsDialog.pbCurrentStatus.minimum);
  Amarok.debug("maximum: " + gv_toolsDialog.pbCurrentStatus.maximum);
  Amarok.debug("active Index: " + Amarok.Playlist.activeIndex());
  Amarok.debug("Total Track Count: " + Amarok.Playlist.totalTrackCount());
  Amarok.debug("Value: " + gv_toolsDialog.pbCurrentStatus.value);
}

function GNProcessBeforeOutput(){
/**************************************************************************/ 
// set screen fields properties before pop up is called
/**************************************************************************/ 
  debug("GNProcessBeforeOutput");
  if (gv_toolsDialog.rbPlayList.checked){
    gv_toolsDialog.rbAfterHour.checked = false;
    gv_toolsDialog.teHours.enabled = false;
  }
  else if (gv_toolsDialog.rbAfterHour.checked){
    gv_toolsDialog.rbPlayList.checked = false;
    gv_toolsDialog.teHours.enabled = true;
  }
  if (gv_toolsDialog.pbOnOff.checked){
    gv_toolsDialog.pbOnOff.text = "";
    gv_toolsDialog.pbOnOff.toolTip = (qsTranslate("GoodNightGUI","Good Night is active"));
    gv_toolsDialog.pbOnOff.icon =  new QIcon(Amarok.Info.scriptPath() + "/icons/jockey-enabled.png");

  } else { 
    gv_toolsDialog.pbOnOff.text =  "";
    gv_toolsDialog.pbOnOff.toolTip = (qsTranslate("GoodNightGUI","Good Night is inactive"));
    gv_toolsDialog.pbOnOff.icon =  new QIcon(Amarok.Info.scriptPath() + "/icons/jockey-disabled.png");
  }

// properties for time 
  if (gv_toolsDialog.cbLogOutDialog.checked){
    gv_toolsDialog.sbCancelWait.enabled = true;
  } else {
    gv_toolsDialog.sbCancelWait.enabled = false;
  }

  GNSetProgressBar();
}

function GNSettingsPopUp(){
/**************************************************************************/ 
// this function builds setting pop up
// reads configuration
/**************************************************************************/ 
 debug("GNSettingsPopUp");

// connect UI elements to handler
 gv_toolsDialog.buttonBox.button(QDialogButtonBox.Close).clicked.connect(null, GNActionClose); 
 gv_toolsDialog.rbPlayList.toggled.connect(null, GNActionToggle);
 gv_toolsDialog.rbAfterHour.toggled.connect(null, GNActionToggle);
 gv_toolsDialog.cbLogOutDialog.toggled.connect(null, GNActionLogOutDialog);
 gv_toolsDialog.pbOnOff.clicked.connect(null, GNActionToggle);
//init combo box
 if (gv_toolsDialog.ddKindShutdown.count == 0){
  icon = new QIcon(Amarok.Info.iconPath("system-shutdown", 16));
  gv_toolsDialog.ddKindShutdown.addItem(icon,qsTranslate("GoodNightGUI","Shutdown PC"), "SHUTDOWN");
  icon = new QIcon(Amarok.Info.iconPath("system-suspend-hibernate", 16));
  gv_toolsDialog.ddKindShutdown.addItem(icon,qsTranslate("GoodNightGUI","Hibernate"), "HIBERNATE");
  icon = new QIcon(Amarok.Info.iconPath("system-suspend", 16));
  gv_toolsDialog.ddKindShutdown.addItem(icon,qsTranslate("GoodNightGUI","Sleep"), "SUSPEND"); 
  icon = new QIcon(Amarok.Info.iconPath("amarok", 16));
  gv_toolsDialog.ddKindShutdown.addItem(icon,qsTranslate("GoodNightGUI","Quit Amarok"), "QUIT_AMAROK");
  icon = new QIcon(Amarok.Info.iconPath("media-playback-stop", 16));
  gv_toolsDialog.ddKindShutdown.addItem(icon,qsTranslate("GoodNightGUI","Stop Amarok"), "STOP_AMAROK");
  gv_toolsDialog.ddKindShutdown.insertSeparator(3);
 }

// set actual data 
 gv_toolsDialog.ddKindShutdown.currentIndex = gv_ddCurrentIndex;
 gv_toolsDialog.rbAfterHour.checked = gv_rbAfterHour;
 gv_toolsDialog.rbPlayList.checked = gv_rbPlayList;
 gv_toolsDialog.pbOnOff.checked = gv_pbOnOff;
 gv_toolsDialog.sbCancelWait.value = gv_sbCancelWait; 
 gv_toolsDialog.teHours.time = gv_teHours;
 gv_toolsDialog.cbLogOutDialog.checked = gv_cbLogOutDialog;
// set UI element properties
 GNProcessBeforeOutput();

 gv_toolsDialog.show();
// delete init mode 
 if (gv_init){ gv_init = false; }
}

function GNReadConfig(){
/**************************************************************************/ 
// read stored configuration from file
/**************************************************************************/ 
  debug("GNReadConfig");
  QByteArray.prototype.toString = function()
  {
    ts = new QTextStream( this, QIODevice.ReadOnly );
    return ts.readAll();
  }

  var f = new QFile( Amarok.Info.scriptPath() + "/config" );
  f.open(QIODevice.ReadOnly);
  var line = new QTextStream(f);
  var i = 0;
  while (i < 7)
  {
  switch (i) {           
      case 0: gv_rbPlayList     = line.readLine().toString();
              Amarok.debug("config read: gv_rbPlayList = " + gv_rbPlayList);
              if (gv_rbPlayList == "true"){
                gv_rbPlayList = true;
              }else{
                gv_rbPlayList = false;
              }
              gv_toolsDialog.rbPlayList.checked = gv_rbPlayList;
              break;
      case 1: gv_rbAfterHour    = line.readLine().toString();
              Amarok.debug("config read: gv_rbAfterHour = " + gv_rbAfterHour);
              if (gv_rbAfterHour == "true"){// true <> ture in JS, type issue?!
                gv_rbAfterHour = true;
              }else{
                gv_rbAfterHour = false;
              }  
              gv_toolsDialog.rbAfterHour.checked = gv_rbAfterHour;
              break;    
      case 2: var hour        = line.readLine().toString(); 
              break;
      case 3: var minute  = line.readLine().toString(); 
              gv_teHours = new QTime(hour, minute);
              Amarok.debug("config read: gv_teHours = " + gv_teHours);
              gv_toolsDialog.teHours.time = gv_teHours;
              break;
      case 4: gv_ddCurrentIndex = line.readLine().toString(); 
              Amarok.debug("config read: gv_ddCurrentIndex = " + gv_ddCurrentIndex);
              gv_toolsDialog.ddKindShutdown.currentIndex = gv_ddCurrentIndex;
              break;
      case 5: gv_cbLogOutDialog = line.readLine().toString();
              if (gv_cbLogOutDialog == "true"){// true <> ture in JS, type issue?!
                gv_cbLogOutDialog = true;
              }else{
                gv_cbLogOutDialog = false;
              } 
              Amarok.debug("config read: gv_cbLogOutDialog = " + gv_cbLogOutDialog);
              gv_toolsDialog.cbLogOutDialog.checked = gv_cbLogOutDialog;
              break;
      case 6: gv_sbCancelWait   = line.readLine().toString(); 
              Amarok.debug("config read: gv_sbCancelWait = " + gv_sbCancelWait);
             // gv_toolsDialog.sbCancelWait.value = gv_sbCancelWait;
              break;
    }
    i++;
  }
  f.close();
  Amarok.debug("config read finsihed");
}

function GNCompareConfig(){
/**************************************************************************/ 
// compare actual data with file (avoid write access, each time)
/**************************************************************************/ 
  debug("GNCompareConfig");
  QByteArray.prototype.toString = function()
  {
    ts = new QTextStream( this, QIODevice.ReadOnly );
    return ts.readAll();
  }

  var f = new QFile( Amarok.Info.scriptPath() + "/config" );
  f.open(QIODevice.ReadOnly);
  var line = new QTextStream(f);
  var i = 0;
  while (i < 7)
  {
  switch (i) {           
      case 0: var rbPlayList     = line.readLine().toString();
              Amarok.debug("config compare 0: " + rbPlayList + " = " + gv_rbPlayList);
              if (rbPlayList == "true"){
                rbPlayList = true;
              }else{
                rbPlayList = false;
              }
              if (rbPlayList != gv_rbPlayList){
		return false;
              }
              break;
      case 1: var rbAfterHour    = line.readLine().toString();
              Amarok.debug("config compare 1: " + rbAfterHour  + " = " + gv_rbAfterHour);
              if (rbAfterHour == "true"){// true <> ture in JS, type issue?!
                rbAfterHour = true;
              }else{
                rbAfterHour = false;
              }  
              if (rbAfterHour != gv_rbAfterHour){
		return false;
              }
              break;    
      case 2: var hour        = line.readLine().toString(); 
              break;
      case 3: var minute  = line.readLine().toString(); 
              var teHours = new QTime(hour, minute);
              Amarok.debug("config compare 2: " + teHours  + " = " + gv_teHours); 
              if (teHours != gv_teHours){
		return false;
              }
              break;
      case 4: var ddCurrentIndex = line.readLine().toString(); 
              Amarok.debug("config compare 3: " + ddCurrentIndex  + " = " + gv_ddCurrentIndex);
              if (ddCurrentIndex != gv_ddCurrentIndex){
		return false;
              }
              break;
      case 5: var cbLogOutDialog = line.readLine().toString();
              if (cbLogOutDialog == "true"){// true <> ture in JS, type issue?!
                cbLogOutDialog = true;
              }else{
                cbLogOutDialog = false;
              } 
              Amarok.debug("config compare 4: " + cbLogOutDialog  + " = " + gv_cbLogOutDialog);
              if (cbLogOutDialog != gv_cbLogOutDialog){
		return false;
              }
              break;
      case 6: var sbCancelWait   = line.readLine().toString(); 
              Amarok.debug("config compare 5: " + sbCancelWait  + " = " + gv_sbCancelWait);
              if (sbCancelWait != gv_sbCancelWait){
		return false;
              }
              break;
    }
    i++;
  }
  f.close();
  Amarok.debug("config compare finsihed");
  return true;
}

function GNWriteConfig(){
/**************************************************************************/ 
// store configuration to file
/**************************************************************************/ 
  debug("GNWriteConfig");

  if (GNCompareConfig() == false){
    var f = new QFile( Amarok.Info.scriptPath() + "/config" );
    f.open(QIODevice.ReadWrite);
    var line = new QTextStream(f);
    line.writeString(gv_rbPlayList + "\n");
    line.writeString(gv_rbAfterHour + "\n");
    line.writeString(gv_teHours.hour());
    line.writeString("\n");
    line.writeString(gv_teHours.minute());
    line.writeString("\n");
    line.writeInt(gv_ddCurrentIndex);
    line.writeString("\n" + gv_cbLogOutDialog + "\n");
    line.writeInt(gv_sbCancelWait);
    line.writeString("\n");
    f.close();
    Amarok.debug("config written");
 }else{
    Amarok.debug("config not written, no changes");
 }
}
function qsTranslate(context,st){
/**************************************************************************/ 
// translation function needed for QT
/**************************************************************************/ 
	return QCoreApplication.translate(context,st);
}

function debug(string){
/**************************************************************************/ 
// debug current situation of each function at beginning
/**************************************************************************/
Amarok.debug("FUNCTION : Engine State :" + Amarok.Engine.engineState() );
Amarok.debug("FUNCTION " + string + " : reached ...");
try{Amarok.debug("FUNCTION " + string + " : Globals : " + gv_pbOnOff + gv_rbPlayList + gv_rbAfterHour + 
gv_teHours + gv_ddCurrentIndex + gv_cbLogOutDialog + gv_sbCancelWait);}catch(e){Amarok.debug(e)};
try{Amarok.debug("FUNCTION " + string + " : Dialog  : " + gv_toolsDialog.pbOnOff.checked + 
gv_toolsDialog.rbPlayList.checked + gv_toolsDialog.rbAfterHour.checked +  
gv_toolsDialog.teHours.time + gv_toolsDialog.ddKindShutdown.currentIndex + 
gv_toolsDialog.cbLogOutDialog.checked + gv_toolsDialog.sbCancelWait.value);}catch(e){Amarok.debug(e)};
}

/******************************** Translation *****************************/
const lang = QLocale.system().name();
var translator = new QTranslator();
translator.load("locale_"+lang, Amarok.Info.scriptPath()+"/translations/");
QCoreApplication.installTranslator(translator);
/************************** load Ui-file *******************************/ 
gv_uiFile.open(QIODevice.ReadOnly);
gv_toolsDialog = gv_uiLoader.load(gv_uiFile,this);
gv_uiFile.close();

GNReadConfig();

/************************** Set Main Window *******************************/ 
Amarok.debug("Amarok version: "+Amarok.Info.version());
Amarok.Window.addToolsMenu("GNSettingsGUI", qsTranslate("GoodNightGUI","Good Night ..."), "player-time" );
Amarok.Window.ToolsMenu.GNSettingsGUI["triggered()"].connect(GNSettingsPopUp);
}